//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
    TrackBar1Change(this);
    canceled=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
    checkMem();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::checkMem()
{
    LPMEMORYSTATUS memStatus=new MEMORYSTATUS;
    GlobalMemoryStatus(memStatus);
    Memo1->Lines->Clear();
    Memo1->Lines->Add("Physical installed memory: "+AnsiString((int)memStatus->dwTotalPhys)+" Bytes ("+AnsiString((int)(memStatus->dwTotalPhys/16000000)*16)+" Mb)");
    Memo1->Lines->Add("Percent of physical memory in use: "+AnsiString((int)memStatus->dwMemoryLoad)+"%");
    Memo1->Lines->Add("Total paging file size: "+AnsiString((int)memStatus->dwTotalPageFile)+" Bytes ("+AnsiString((int)(memStatus->dwTotalPageFile/1000000))+" Mb)");
    Memo1->Lines->Add("Paging (virtual) memory still avaliable: "+AnsiString((int)memStatus->dwAvailPageFile)+" Bytes ("+AnsiString((int)(memStatus->dwAvailPageFile/1000000))+" Mb)");
    delete memStatus;
}
void __fastcall TForm1::TrackBar1Change(TObject *Sender)
{
    msecBox->Text=AnsiString((double)TrackBar1->Position/1000.0);
    Timer1->Interval=TrackBar1->Position;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
    Timer1->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
    int i, j;
    int allocBy=Edit1->Text.ToInt();
    int **ff;
    canceled=false;
    for (i=0; i<10000 && !canceled; i++) {
        ff=new int*[1000];
        for (j=0; j<1000; j++) {
            ff[j]=0;
        }
        for (j=0; j<1000 && !canceled; j++) {
            ff[j]=new int[allocBy];
            Application->ProcessMessages();
        }
        for (j=0; j<1000; j++) {
            delete []ff[j];
            ff[j]=0;
            Application->ProcessMessages();
        }
        delete []ff;
        Application->ProcessMessages();
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
    canceled=true;    
}
//---------------------------------------------------------------------------

